# -*- encoding:utf-8 -*-

# oVXe ()
# Copyright (C) 2007 HORIKAWA Hisashi. All rights reserved.
#     http://www.nslabs.jp/bside/


require 'validating_base'

class BankAccountSearchBox < ValidatingBase
  attr_accessor :text
end

# Ћs
class OurBanksController < ApplicationController

  # GETs should be safe (see http://www.w3.org/2001/tag/doc/whenToUseGet.html)
  verify :method => :post, :only => [ :destroy, :create, :update ],
         :redirect_to => { :action => :list }
  
  def index
    list
    render :action => 'list'
  end

  def list
    @our_bank_pages, @our_banks = paginate :our_banks, :per_page => 10
  end

  def show
    @our_bank = OurBank.find(params[:id])
  end
  
  # VȋIj
  def new
    @our_bank = OurBank.new
  end
  
  def new2
    @search = BankAccountSearchBox.new params[:search]
    if @search.text.to_s.strip == ''
      @search.errors.add_to_base 'eLXg͂ĂB'
      render :action => 'new'
      return
    end
    t = '%' + Bank.zen2han(@search.text.strip) + '%' # TODO:fixme
    if @search.text.to_i != 0
      @bank_accounts = BankAccount.find :all, :conditions => ['ac_number = ?', @search.text], :limit => 31
    else
      @bank_accounts = BankAccount.find :all, :conditions => ['kana_name like ?', t], :limit => 31
    end
  end
  
  def new3
    @bank_account = BankAccount.find params[:bank_account]
  end

  def create
    @our_bank = OurBank.new(params[:our_bank])
    if @our_bank.save
      flash[:notice] = 'OurBank was successfully created.'
      redirect_to :action => 'list'
    else
      render :action => 'new'
    end
  end

  def edit
    @our_bank = OurBank.find(params[:id])
  end

  def update
    @our_bank = OurBank.find(params[:id])
    if @our_bank.update_attributes(params[:our_bank])
      flash[:notice] = 'OurBank was successfully updated.'
      redirect_to :action => 'show', :id => @our_bank
    else
      render :action => 'edit'
    end
  end

  def destroy
    OurBank.find(params[:id]).destroy
    redirect_to :action => 'list'
  end
end
